import { TransformColumns, ColumnsType, Key, TableLocale, GetPopupContainer } from '../interface';
import { FilterState } from './useFilter/index';
export declare function getFilterData<RecordType>(data: RecordType[], filterStates: FilterState<RecordType>[]): RecordType[];
interface FilterConfig<RecordType> {
    prefixCls: string;
    dropdownPrefixCls: string;
    columns: ColumnsType<RecordType>;
    locale: TableLocale;
    onFilterChange: (filters: Record<string, Key[] | null>, filterStates: FilterState<RecordType>[]) => void;
    getPopupContainer?: GetPopupContainer;
    inlineFilterVisble?: boolean;
    inlineFilter?: boolean;
}
declare function useFilter<RecordType>({ prefixCls, dropdownPrefixCls, columns, onFilterChange, getPopupContainer, locale: tableLocale, inlineFilterVisble, inlineFilter, }: FilterConfig<RecordType>): [TransformColumns<RecordType>];
export default useFilter;
