"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFilterData = getFilterData;
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _util = require("../util");

var _input = _interopRequireDefault(require("../../input"));

var _useSyncState3 = _interopRequireDefault(require("./useSyncState"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

// export interface FilterState<RecordType> {
//   column: ColumnType<RecordType>;
//   key: Key;
//   filteredKeys?: Key[] | null;
//   forceFiltered?: boolean;
// }
function collectFilterStates(columns, init, pos) {
  var filterStates = [];
  (columns || []).forEach(function (column, index) {
    var columnPos = (0, _util.getColumnPos)(index, pos);

    if ('children' in column) {
      filterStates = [].concat(_toConsumableArray(filterStates), _toConsumableArray(collectFilterStates(column.children, init, columnPos)));
    } else {
      // filterStates.push({
      //     column,
      //     key: getColumnKey(column, columnPos),
      //     filterComponent: column.filterComponent,
      //     filteredKeys:
      //         init && column.defaultFilteredValue ? column.defaultFilteredValue! : undefined,
      //     forceFiltered: column.filtered,
      // });
      if ('filteredValue' in column) {
        // Controlled
        filterStates.push({
          column: column,
          key: (0, _util.getColumnKey)(column, columnPos),
          filteredKeys: column.filteredValue,
          forceFiltered: column.filtered
        });
      } else {
        // Uncontrolled
        filterStates.push({
          column: column,
          key: (0, _util.getColumnKey)(column, columnPos),
          filteredKeys: init && column.defaultFilteredValue ? column.defaultFilteredValue : undefined,
          forceFiltered: column.filtered
        });
      }
    }
  });
  return filterStates;
}

function injectFilter(prefixCls, dropdownPrefixCls, columns, filterStates, triggerFilter, getPopupContainer, locale, pos, inlineFilterVisble, inlineFilter) {
  return columns.map(function (column, index) {
    var columnPos = (0, _util.getColumnPos)(index, pos);

    if (inlineFilter) {
      return _extends(_extends({}, column), {
        title: function title(renderProps) {
          return /*#__PURE__*/React.createElement(InlineFilterWrapper, {
            renderProps: renderProps,
            column: column,
            inlineFilterVisble: inlineFilterVisble,
            filterPrefixCls: dropdownPrefixCls,
            columns: columns,
            filterStates: filterStates,
            triggerFilter: triggerFilter,
            locale: locale,
            index: index
          });
        }
      });
    }

    if ('children' in column) {
      return _extends(_extends({}, column), {
        children: injectFilter(prefixCls, dropdownPrefixCls, column.children, filterStates, triggerFilter, getPopupContainer, locale, columnPos, inlineFilterVisble)
      });
    }

    return column;
  });
}

function generateFilterInfo(filterStates) {
  var currentFilters = {};
  filterStates.forEach(function (_ref) {
    var key = _ref.key,
        filteredKeys = _ref.filteredKeys;
    currentFilters[key] = filteredKeys || null;
  });
  return currentFilters;
}

function flattenKeys(filters) {
  var keys = [];
  (filters || []).forEach(function (_ref2) {
    var value = _ref2.value,
        children = _ref2.children;
    keys.push(value);

    if (children) {
      keys = [].concat(_toConsumableArray(keys), _toConsumableArray(flattenKeys(children)));
    }
  });
  return keys;
}

function getFilterData(data, filterStates) {
  return filterStates.reduce(function (currentData, filterState) {
    var _filterState$column = filterState.column,
        onFilter = _filterState$column.onFilter,
        filters = _filterState$column.filters,
        filteredKeys = filterState.filteredKeys;

    if (onFilter && filteredKeys && filteredKeys.length) {
      return currentData.filter(function (record) {
        return filteredKeys.some(function (key) {
          var keys = flattenKeys(filters);
          var keyIndex = keys.findIndex(function (k) {
            return String(k) === String(key);
          });
          var realKey = keyIndex !== -1 ? keys[keyIndex] : key;
          return onFilter(realKey, record);
        });
      });
    }

    return currentData;
  }, data);
}

function useFilter(_ref3) {
  var prefixCls = _ref3.prefixCls,
      dropdownPrefixCls = _ref3.dropdownPrefixCls,
      columns = _ref3.columns,
      onFilterChange = _ref3.onFilterChange,
      getPopupContainer = _ref3.getPopupContainer,
      tableLocale = _ref3.locale,
      inlineFilterVisble = _ref3.inlineFilterVisble,
      inlineFilter = _ref3.inlineFilter;

  var _React$useState = React.useState(collectFilterStates(columns, true)),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      filterStates = _React$useState2[0],
      setFilterStates = _React$useState2[1];

  var mergedFilterStates = React.useMemo(function () {
    var collectedStates = collectFilterStates(columns, false); // Return if not controlled

    if (collectedStates.every(function (_ref4) {
      var filteredKeys = _ref4.filteredKeys;
      return filteredKeys === undefined;
    })) {
      return filterStates;
    }

    return collectedStates;
  }, [columns, filterStates]);

  var triggerFilter = function triggerFilter(filterState) {
    var newFilterStates = mergedFilterStates.filter(function (_ref5) {
      var key = _ref5.key;
      return key !== filterState.key;
    });
    newFilterStates.push(filterState);
    setFilterStates(newFilterStates);
    onFilterChange(generateFilterInfo(newFilterStates), newFilterStates);
  };

  var transformColumns = function transformColumns(innerColumns) {
    return injectFilter(prefixCls, dropdownPrefixCls, innerColumns, mergedFilterStates, triggerFilter, getPopupContainer, tableLocale, undefined, inlineFilterVisble, inlineFilter);
  };

  return [transformColumns];
}

function InlineFilterWrapper(_ref6) {
  var index = _ref6.index,
      pos = _ref6.pos,
      column = _ref6.column,
      filterStates = _ref6.filterStates,
      inlineFilterVisble = _ref6.inlineFilterVisble,
      filterPrefixCls = _ref6.filterPrefixCls,
      triggerFilter = _ref6.triggerFilter;
  var columnPos = (0, _util.getColumnPos)(index, pos);
  var columnKey = (0, _util.getColumnKey)(column, columnPos);
  var filterState = filterStates.find(function (_ref7) {
    var key = _ref7.key;
    return columnKey === key;
  }); // // ===================== Select Keys =====================

  var propFilteredKeys = filterState && filterState.filteredKeys || [];

  var _useSyncState = (0, _useSyncState3["default"])(propFilteredKeys || []),
      _useSyncState2 = _slicedToArray(_useSyncState, 2),
      getFilteredKeysSync = _useSyncState2[0],
      setFilteredKeysSync = _useSyncState2[1]; // React.useEffect(() => {
  //     setFilteredKeysSync(propFilteredKeys);
  // }, [propFilteredKeys])


  var onSelectKeys = function onSelectKeys(_ref8) {
    var selectedKeys = _ref8.selectedKeys;
    setFilteredKeysSync(selectedKeys);
    var mergedKeys = selectedKeys && selectedKeys.length ? selectedKeys : null;

    if (mergedKeys === null && (!filterState || !filterState.filteredKeys)) {
      return null;
    }

    triggerFilter({
      column: column,
      key: columnKey,
      filteredKeys: mergedKeys
    });
  }; // React.useEffect(() => {
  //     onSelectKeys({ selectedKeys: propFilteredKeys || [] });
  // }, [propFilteredKeys]);


  var defautInput = function defautInput(_ref9) {
    var setSelectedKeys = _ref9.setSelectedKeys,
        selectedKeys = _ref9.selectedKeys;

    if (filterState) {
      return /*#__PURE__*/React.createElement(_input["default"], {
        placeholder: "\u8F93\u5165\u7B5B\u9009",
        onChange: function onChange(e) {
          return setSelectedKeys(e.target.value ? [e.target.value] : []);
        },
        value: selectedKeys[0]
      });
    } else {
      return null;
    }
  };

  var searchNode;
  var filterComponent = defautInput;

  if ('filterComponent' in column) {
    filterComponent = column.filterComponent;
  }

  if (typeof filterComponent === 'function') {
    searchNode = filterComponent({
      prefixCls: "".concat(filterPrefixCls, "-custom"),
      setSelectedKeys: function setSelectedKeys(selectedKeys) {
        return onSelectKeys({
          selectedKeys: selectedKeys
        });
      },
      selectedKeys: getFilteredKeysSync(),
      confirm: function confirm() {},
      clearFilters: function clearFilters() {},
      filters: column.filters,
      visible: inlineFilterVisble || false
    });
  } else if (filterComponent) {
    searchNode = filterComponent;
  }

  return /*#__PURE__*/React.createElement("div", null, (0, _util.renderColumnTitle)(column.title, {}), /*#__PURE__*/React.createElement("div", {
    style: {
      paddingTop: 10,
      marginBottom: -10,
      display: inlineFilterVisble ? 'block' : 'none'
    },
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }, searchNode));
}

var _default = useFilter;
exports["default"] = _default;